/// Copyright (c) 2010 Ruben Penalva. All rights reserved.
/// Redistribution and use in source and binary forms, with or without modification, 
/// are permitted provided that the following conditions are met:
///    1. Redistributions of source code must retain the above copyright notice, this 
///    list of conditions and the following disclaimer.
///    2. Redistributions in binary form must reproduce the above copyright notice,
///    this list of conditions and the following disclaimer in the documentation and/or
///    other materials provided with the distribution.
///    3. The name of the author may not be used to endorse or promote products derived
///    from this software without specific prior written permission.
///
/// THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES,
/// INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR 
/// A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, 
/// INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED 
/// TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
/// INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT 
/// LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF 
/// THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

#include "OpenglLastError.h"

using namespace TestFrameWork;

#include <assert.h>

OpenglLastError::OpenglLastError(void)	:	m_code(glGetError()), m_string(EnumToString(m_code))
{
}

OpenglLastError::~OpenglLastError(void)
{
}

DWORD OpenglLastError::GetErrorCode(void) const
{
	return (DWORD)m_code;
}

const std::wstring& OpenglLastError::ToString(void) const
{
	return m_string;
}

std::wstring OpenglLastError::EnumToString(GLenum code)
{
	std::wstring string(L"");

	switch(code)
	{
		case GL_NO_ERROR:
			string = L"GL_NO_ERROR";
			break;

		case GL_INVALID_ENUM:
			string = L"GL_INVALID_ENUM";
			break;

		case GL_INVALID_VALUE:
			string = L"GL_INVALID_VALUE";
			break;

		case GL_INVALID_OPERATION:
			string = L"GL_INVALID_OPERATION";
			break;

		case GL_STACK_OVERFLOW:
			string = L"GL_STACK_OVERFLOW";
			break;

		case GL_STACK_UNDERFLOW:
			string = L"GL_STACK_UNDERFLOW";
			break;

		case GL_OUT_OF_MEMORY:
			string = L"GL_OUT_OF_MEMORY";
			break;

		case GL_TABLE_TOO_LARGE:
			string = L"GL_TABLE_TOO_LARGE";
			break;

		default:
			assert(false);
			break;
	}

	return string;
}

bool OpenglLastError::IsLastErrorSet(void)
{
	return m_code != GL_NO_ERROR;
}